### Function

# Pango get_log_attrs

#### Declaration [src]

    void
    pango_get_log_attrs (
      const char* text,
      int length,
      int level,
      PangoLanguage* language,
      PangoLogAttr* attrs,
      int attrs_len
    )

#### Description [src]

Computes a `PangoLogAttr` for each character in `text`.

The `attrs` array must have one `PangoLogAttr` for each position in `text`; if `text` contains N characters, it has N+1 positions, including the last position at the end of the text. `text` should be an entire paragraph; logical attributes can’t be computed without context (for example you need to see spaces on either side of a word to know the word is a word).

#### Parameters

`text`

  Type: `const char*`

  Text to process. Must be valid UTF-8.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`length`

  Type: `int`

  Length in bytes of `text`.

`level`

  Type: `int`

  Embedding level, or -1 if unknown.

`language`

  Type: `PangoLanguage`

  Language tag.

  The data is owned by the caller of the function.

`attrs`

  Type: An array of `PangoLogAttr`

  Array with one `PangoLogAttr` per character in `text`, plus one extra, to be filled in.

  The argument will be set by the function.
  The length of the array is specified in the `attrs_len` argument.
  The returned data is owned by the function.

`attrs_len`

  Type: `int`

  Length of `attrs` array.